#ifndef _RTP_DELAY_HH_
#define _RTP_DELAY_HH_

#include "sys_time.hh"
#include "statistic.hh"

class TimeVar
{
private:
  unsigned int*  data;
  double         start_time;
  double         time_window;
  double         period;
  double         last_add;
  double         last_read;
  unsigned int   last_index;
  unsigned int   max_index;
  unsigned int   counter;
public:
  TimeVar(double,double,double);
  ~TimeVar();
  void Add(double);
  unsigned int Count(double);
};

class PlayoutDelay
{
public:
  virtual int Delay(sys_time&,uint32,uint16) = 0;
  virtual ~PlayoutDelay();
  virtual void ForceSync();
};

class MPEG_Delay : public PlayoutDelay
{
private:
  sys_time      Dmax;   
  sys_time      Drift;
  sys_time      Tau;
  sys_time      A0;     
  uint32        T0;
  uint16        last_Sn;
  sys_time      last_An;
  int           first; 
  int           need_resync;
  unsigned int tot_pck;
  unsigned int tot_pck_loss_misord;
  unsigned int tot_pck_net_loss;
  unsigned int tot_pck_loss_late;
  unsigned int tot_pck_loss;
  TimeVar*      ppck;
  TimeVar*      ppck_loss;
  Statistic*    pstat_loss_late;
  Statistic*    pstat_ploss;
  Statistic*    pstat_pck;
  Statistic*    pstat_pck_loss;
  Statistic*    pstat_dmax;
  Statistic*    pstat_PnAn;
  Statistic*    pstat_netloss;
public:
  MPEG_Delay();
  ~MPEG_Delay();
  int Delay(sys_time&,uint32,uint16);
  void ForceSync();
};

#endif
